<?php 

/**
 * Plazart Framework
 * Author: Sonle
 * Version: 1.1
 * @copyright   Copyright (C) 2012 - 2013 TemPlaza.com. All rights reserved.
 * @license     GNU General Public License version 2 or later
 */

class TZTemplateCache {
    //
    private $parent;
    //
    function __construct($parent) {
    	$this->parent = $parent;
    }
    //
    function registerCache($url)
    {
        $document = JFactory::getDocument();
        $arr = array();

        foreach ($document->_styleSheets as $strSrc => $strAttr) {
            if ($strAttr['mime'] == 'text/css') {
                if (preg_match('/' . preg_replace('/\//', '\\/', $url) . '/', $strSrc)) {
                    $newSrc = substr($strSrc, 0, -4) . '.min.css';
                    $arr[] = $newSrc;
                } else {
                    $arr[] = $strSrc;
                }
                unset($document->_styleSheets[$strSrc]);
            }
        }
        foreach ($arr as $el) {
            $document->addStylesheet($el);
        }

        tzimport ('minify/csscompressor') ;
        $document->_style["text/css"]  =   Minify_CSS_Compressor::process ($document->_style["text/css"]);
    }

    function registerJSCompression($url)
    {
        $document = & JFactory::getDocument();
        $arr = array();

        foreach ($document->_scripts as $strSrc => $strAttr) {
            if (preg_match('/' . preg_replace('/\//', '\\/', $url) . '/', $strSrc)) {
                $newSrc = str_replace(JFile::getName($strSrc), 'packed/' . substr(JFile::getName($strSrc), 0, -3) . '.min.js', $strSrc);
                $arr[] = $newSrc;
            } else {
                $arr[] = $strSrc;
            }
            unset($document->_scripts[$strSrc]);
        }
        foreach ($arr as $el) {
            $document->addScript($el);
        }

        tzimport ('minify/javascriptpacker');
        $packer = new JavaScriptPacker($document->_script["text/javascript"], 'Normal', true, false);
        $document->_script["text/javascript"] = $packer->pack();
    }
}
// EOF