<?php

/**
 * Plazart Framework
 * Author: Sonle
 * Version: 1.1
 * @copyright   Copyright (C) 2012 - 2013 TemPlaza.com. All rights reserved.
 * @license     GNU General Public License version 2 or later
 */
 
// No direct access.
defined('_JEXEC') or die;

tzimport('core/parser');
require_once(TZ_TEMPLATE_PATH . DS . 'libraries' . DS . 'helpers' . DS . 'browser.php');
require_once(TZ_TEMPLATE_PATH . DS . 'libraries' . DS . 'helpers' . DS . 'api.php');
require_once(TZ_TEMPLATE_PATH . DS . 'libraries' . DS . 'helpers' . DS . 'cache.php');
require_once(TZ_TEMPLATE_PATH . DS . 'libraries' . DS . 'helpers' . DS . 'layout.php');
require_once(TZ_TEMPLATE_PATH . DS . 'libraries' . DS . 'helpers' . DS . 'menu.php');
require_once(TZ_TEMPLATE_PATH . DS . 'libraries' . DS . 'helpers' . DS . 'social.php');
require_once(TZ_TEMPLATE_PATH . DS . 'libraries' . DS . 'helpers' . DS . 'utilities.php');

/*
* Main framework class
*/
class PlazartRender {
    // template name
    public $name = TZ_TEMPLATE;
    // access to the standard Joomla! template API
    public $API;
    // access to the helper classes
    public $bootstrap;
    public $cache;
    public $layout;
    public $social;
    public $utilities;
    public $menu;
    // detected browser:
    public $browser;
    // page config
    public $config;
    // page menu
    public $mainmenu;
    // mobile menu
    public $mobilemenu;
    // module styles
    public $module_styles;
    // page suffix
    public $page_suffix;
    
    // constructor
    public function __construct($tpl, $embed_mode = false) {
		// put the template handler into API field
        $this->API = new TZTemplateAPI($tpl);
        $this->APITPL = $tpl;
        // get the helpers

        $this->cache = new TZTemplateCache($this);
        $this->social = new TZTemplateSocial($this);
        $this->utilities = new TZTemplateUtilities($this);
        $this->menu = new TZTemplateMenu($this);
        // create instance of TZBrowser class and detect
        $browser = new TZBrowser();
        $this->browser = $browser->result;
        // get the params
        $this->getParameters();
        // get type and generate menu
        $this->mainmenu = $this->menu->getMenuType();
        $this->mobilemenu = $this->menu->getMenuType(true);
        // load the layout helper
        $this->layout = new TZTemplateLayout($this);
        // get the layout
        if(!$embed_mode) {   
    		if ($this->browser->get('browser') == 'facebook') { // facebook mode
				$this->getLayout('facebook');
			} else { // normal mode
                $layout =   $this->API->get('layout','default');
                $this->getLayout($layout);
    		}
        }
        TZRules::setRule('/<script src="\/media\/system\/js\/core.js" type="text\/javascript"><\/script>/mis','<script src="'.TZ_TEMPLATE_REL.'/js/hash.js" type="text/javascript"></script>'."\n".'<script src="/media/system/js/core.js" type="text/javascript"></script>');
        // parse FB and Twitter buttons
        $this->social->socialApiParser($embed_mode);
    }
    
    // get the template parameters in PHP form
    public function getParameters() {
        // create config object
        $this->config = new JObject();
        // set layout override param
    	$this->config->set('content_width_override', $this->utilities->overrideArrayParse($this->API->get('content_width_for_pages', '')));
	}
   
    // function to get layout for specified mode
    public function getLayout($mode) {
        // check the override
        $layoutpath = TZ_TEMPLATE_PATH . DS . 'layouts' . DS . $mode . '.php';
        if (is_file($layoutpath)) {
            include ($layoutpath);
        } else {
            echo 'Default layout doesn\'t exist!';
        }
    }
}
// EOF